(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA        LRI-CNRS        ENS-CNRS                *)
(*              Rocquencourt         Orsay          Lyon                    *)
(*                                                                          *)
(*                                 Coq V6.3                                 *)
(*                               July 1st 1999                              *)
(*                                                                          *)
(****************************************************************************)
(*                               Peano_dec.v                                *)
(****************************************************************************)

Theorem O_or_S : (n:nat)({m:nat|(S m)=n})+{O=n}.
Proof.
Induction n.
Auto.
Intros p H; Left; Exists p; Auto.
Qed.

Theorem eq_nat_dec : (n,m:nat){n=m}+{~(n=m)}.
Proof.
Induction n; Induction m; Auto.
Intros q H'; Elim (H q); Auto.
Qed.

Hints Resolve O_or_S eq_nat_dec : arith.

(* $Id: Peano_dec.v,v 1.6 1999/06/29 07:48:33 loiseleu Exp $ *)
